# ecoserver
First API draft for Eco. Heavy work in progress and subject to changes.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import ecoserver 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import ecoserver
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import ecoserver
from ecoserver.rest import ApiException
from pprint import pprint

# Configure API key authorization: authtoken
configuration = ecoserver.Configuration()
configuration.api_key['authtoken'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['authtoken'] = 'Bearer'
# Configure API key authorization: authtokentype
configuration = ecoserver.Configuration()
configuration.api_key['authtokentype'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['authtokentype'] = 'Bearer'

# create an instance of the API class
api_instance = ecoserver.AdminApi(ecoserver.ApiClient(configuration))
authtoken = 'authtoken_example' # str | Eco user authentication token.
authtokentype = 'authtokentype_example' # str | Eco user authentication token type.

try:
    api_response = api_instance.admin_get_get_access(authtoken, authtokentype)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AdminApi->admin_get_get_access: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdminApi* | [**admin_get_get_access**](docs/AdminApi.md#admin_get_get_access) | **GET** /api/v1/admin/get/access | 
*AdminApi* | [**admin_get_get_server_name**](docs/AdminApi.md#admin_get_get_server_name) | **GET** /api/v1/admin/get/servername | 
*AdminApi* | [**admin_post_game_export**](docs/AdminApi.md#admin_post_game_export) | **POST** /api/v1/admin/game/export | 
*AdminApi* | [**admin_post_set_access**](docs/AdminApi.md#admin_post_set_access) | **POST** /api/v1/admin/set/access | Sets how accessible this server is.
*AdminApi* | [**admin_post_set_server_name**](docs/AdminApi.md#admin_post_set_server_name) | **POST** /api/v1/admin/set/servername | 
*ChatApi* | [**chat_get_chat**](docs/ChatApi.md#chat_get_chat) | **GET** /api/v1/chat | Returns all non-private player chat messages sent within the given time range.
*ChatApi* | [**chat_get_chat_by_tag**](docs/ChatApi.md#chat_get_chat_by_tag) | **GET** /api/v1/chat/tag | Returns all non-private player chat messages sent to the given tag within the given time range.
*ChatApi* | [**chat_get_chat_messages_sent_by**](docs/ChatApi.md#chat_get_chat_messages_sent_by) | **GET** /api/v1/chat/{username} | Returns all non-private chat messages sent by the given user within the given time range.
*ChatApi* | [**chat_get_next**](docs/ChatApi.md#chat_get_next) | **POST** /api/v1/chat/next | Gets the. &lt;code&gt;numNextMessages&lt;/code&gt; chat messages sent after the given message on the same tag.
*ChatApi* | [**chat_get_previous**](docs/ChatApi.md#chat_get_previous) | **POST** /api/v1/chat/previous | Gets the. &lt;code&gt;numPreviousMessages&lt;/code&gt; chat messages sent before the given message on the same tag.
*ChatApi* | [**chat_send_chat**](docs/ChatApi.md#chat_send_chat) | **GET** /api/v1/chat/sendChat | Sends chat message like username.
*CommandApi* | [**command_exec_command**](docs/CommandApi.md#command_exec_command) | **POST** /api/v1/command/exec | Executes a chat command on the server.
*DataExportApi* | [**data_export_get_action_list**](docs/DataExportApi.md#data_export_get_action_list) | **GET** /api/v1/exporter/actionlist | 
*DataExportApi* | [**data_export_get_environment_list**](docs/DataExportApi.md#data_export_get_environment_list) | **GET** /api/v1/exporter/environmentlist | 
*DataExportApi* | [**data_export_get_export_action**](docs/DataExportApi.md#data_export_get_export_action) | **GET** /api/v1/exporter/actions | 
*DataExportApi* | [**data_export_get_export_environment**](docs/DataExportApi.md#data_export_get_export_environment) | **GET** /api/v1/exporter/environment | 
*DataExportApi* | [**data_export_get_export_species**](docs/DataExportApi.md#data_export_get_export_species) | **GET** /api/v1/exporter/species | 
*DataExportApi* | [**data_export_get_species_list**](docs/DataExportApi.md#data_export_get_species_list) | **GET** /api/v1/exporter/specieslist | 
*DataExportApi* | [**data_export_post_export_actions**](docs/DataExportApi.md#data_export_post_export_actions) | **POST** /api/v1/exporter/actions | 
*DataExportApi* | [**data_export_post_export_all**](docs/DataExportApi.md#data_export_post_export_all) | **POST** /api/v1/exporter/all | 
*DataExportApi* | [**data_export_post_export_chat**](docs/DataExportApi.md#data_export_post_export_chat) | **POST** /api/v1/exporter/chat | 
*DataExportApi* | [**data_export_post_export_environment**](docs/DataExportApi.md#data_export_post_export_environment) | **POST** /api/v1/exporter/environment | 
*DataExportApi* | [**data_export_post_export_species**](docs/DataExportApi.md#data_export_post_export_species) | **POST** /api/v1/exporter/species | 
*ElectionApi* | [**election_add_comment**](docs/ElectionApi.md#election_add_comment) | **POST** /api/v1/elections/addcomment | Adds a comment to the currently running election, if any.
*ElectionApi* | [**election_finish_election**](docs/ElectionApi.md#election_finish_election) | **POST** /api/v1/elections/finishelection | 
*ElectionApi* | [**election_force_election_end**](docs/ElectionApi.md#election_force_election_end) | **POST** /api/v1/elections/forceelectionend | Forces the currently running election to end now, and for the current election winner to become the leader. Can only be called by an admin or dev.
*ElectionApi* | [**election_generate_test_data**](docs/ElectionApi.md#election_generate_test_data) | **POST** /api/v1/elections/generatetestdata | Create a bunch of test elections.
*ElectionApi* | [**election_get_comments**](docs/ElectionApi.md#election_get_comments) | **GET** /api/v1/elections/listcomments | List comments on the election.
*ElectionApi* | [**election_get_elected_title_by_id**](docs/ElectionApi.md#election_get_elected_title_by_id) | **GET** /api/v1/elections/titles/{id} | Returns the elected title with the given id.
*ElectionApi* | [**election_get_election_by_id**](docs/ElectionApi.md#election_get_election_by_id) | **GET** /api/v1/elections/{id} | Returns the election with the given id.
*ElectionApi* | [**election_list_elected_titles**](docs/ElectionApi.md#election_list_elected_titles) | **GET** /api/v1/elections/titles | Returns all elected titles and their occupants matching the given state (active by default).
*ElectionApi* | [**election_list_elections**](docs/ElectionApi.md#election_list_elections) | **GET** /api/v1/elections | Returns all elections that are either active or inactive.
*ElectionApi* | [**election_vote**](docs/ElectionApi.md#election_vote) | **POST** /api/v1/elections/vote | Places a vote on behalf of the given player.  Can only be called if an election is currently running.
*ElectionApi* | [**election_votes**](docs/ElectionApi.md#election_votes) | **GET** /api/v1/elections/votes | Returns a list of votes that were made on the indicated election.
*LawApi* | [**law_generate_test_data**](docs/LawApi.md#law_generate_test_data) | **POST** /api/v1/laws/generatetestdata | Genereate test laws.
*LawApi* | [**law_get_district_map**](docs/LawApi.md#law_get_district_map) | **GET** /api/v1/laws/districtmap/{name} | 
*LawApi* | [**law_get_law**](docs/LawApi.md#law_get_law) | **GET** /api/v1/laws/{id} | Returns the law with the specified id.
*LawApi* | [**law_list**](docs/LawApi.md#law_list) | **GET** /api/v1/laws/byStates/{states} | Returns all laws currently present in the game in the specified states, active by default.
*LawApi* | [**law_list_all**](docs/LawApi.md#law_list_all) | **GET** /api/v1/laws | Returns all laws currently present in the game
*LogApi* | [**log_get_all_logs**](docs/LogApi.md#log_get_all_logs) | **GET** /api/v1/logs | Retrieves a list of all log files on the server.
*LogApi* | [**log_get_category_logs**](docs/LogApi.md#log_get_category_logs) | **GET** /api/v1/logs/{category} | Retrieves a list of all log files in the requested category subfolder if it exists.
*LogApi* | [**log_get_log_file**](docs/LogApi.md#log_get_log_file) | **GET** /api/v1/logs/get | Streams a log file over HTTP/HTTPS to a client.
*MapApi* | [**map_entities**](docs/MapApi.md#map_entities) | **GET** /api/v1/map/entities | Allows access to all entities currently available in the simulation.
*MapApi* | [**map_entity_types**](docs/MapApi.md#map_entity_types) | **GET** /api/v1/map/entitytypes | Allows access to all species currently available in the simulation.
*MapApi* | [**map_get_dimension**](docs/MapApi.md#map_get_dimension) | **GET** /api/v1/map/dimension | Returns the dimension of the world, in blocks.
*MapApi* | [**map_get_property**](docs/MapApi.md#map_get_property) | **GET** /api/v1/map/property | 
*MapApi* | [**map_layer_list**](docs/MapApi.md#map_layer_list) | **GET** /api/v1/map/layerList | List Layer Names.
*MapApi* | [**map_make_map_json**](docs/MapApi.md#map_make_map_json) | **GET** /api/v1/map/map.json | One request to get all required web map data.
*MapApi* | [**map_map_stats**](docs/MapApi.md#map_map_stats) | **GET** /api/v1/map/mapstats | 
*MapApi* | [**map_water_level**](docs/MapApi.md#map_water_level) | **GET** /api/v1/map/waterLevel | Get water height.
*PluginsApi* | [**plugins_get_plugin_config**](docs/PluginsApi.md#plugins_get_plugin_config) | **GET** /api/v1/plugins/{name} | 
*PluginsApi* | [**plugins_get_plugins**](docs/PluginsApi.md#plugins_get_plugins) | **GET** /api/v1/plugins | Gets the list and status of all running plugins on the server.
*PluginsApi* | [**plugins_post_plugin_config**](docs/PluginsApi.md#plugins_post_plugin_config) | **POST** /api/v1/plugins/{name} | Sets the configuration options for the given plugin.
*ProfilingResultsApi* | [**profiling_results_download**](docs/ProfilingResultsApi.md#profiling_results_download) | **GET** /api/v1/profiling-results/{filename} | 
*ProfilingResultsApi* | [**profiling_results_list**](docs/ProfilingResultsApi.md#profiling_results_list) | **GET** /api/v1/profiling-results | Returns the list of generated profiling results.
*RootApi* | [**root_front_page**](docs/RootApi.md#root_front_page) | **GET** /frontpage | 
*RootApi* | [**root_get_admins**](docs/RootApi.md#root_get_admins) | **GET** /admins | Returns the server&#39;s configured administrative users.
*RootApi* | [**root_get_info**](docs/RootApi.md#root_get_info) | **GET** /info | 
*RootApi* | [**root_is_admin**](docs/RootApi.md#root_is_admin) | **GET** /isadmin | Return if the user is an admin and authentication is required.
*StatsApi* | [**stats_generate_test_data**](docs/StatsApi.md#stats_generate_test_data) | **GET** /datasets/generatetestdata | Generates fake stat data for testing.
*StatsApi* | [**stats_get**](docs/StatsApi.md#stats_get) | **GET** /datasets/get | /// Returns Eco.WebServer.Web.Controllers.StatsController.MaximumSamples data points between dayStart and dayEnd of the selected data.             If there are more than Eco.WebServer.Web.Controllers.StatsController.MaximumSamples samples, it will be averaged out to contain exactly Eco.WebServer.Web.Controllers.StatsController.MaximumSamples.///.
*StatsApi* | [**stats_get_flat_list**](docs/StatsApi.md#stats_get_flat_list) | **GET** /datasets/flatlist | /// Returns all stat infos that contain data, formatted as a list, where each key is a list of strings. ///.
*StatsApi* | [**stats_get_list**](docs/StatsApi.md#stats_get_list) | **GET** /datasets/getlist | Returns a \&quot;package\&quot; of multiple statistics in the order of their request.
*StatsApi* | [**stats_get_time_range**](docs/StatsApi.md#stats_get_time_range) | **GET** /datasets/timerange | /// Returns the timerange of the simulation, in days///.
*StatsApi* | [**stats_get_tree_list**](docs/StatsApi.md#stats_get_tree_list) | **GET** /datasets/treelist | Returns all dataset keys, formatted as a tree. ///.
*StatsApi* | [**stats_graphs**](docs/StatsApi.md#stats_graphs) | **GET** /datasets/graphs | Returns the list of premade graphs to be displayed on the front page.
*UsersApi* | [**users_get_users**](docs/UsersApi.md#users_get_users) | **GET** /api/v1/users | 
*WorldLayerApi* | [**world_layer_area_description**](docs/WorldLayerApi.md#world_layer_area_description) | **GET** /api/v1/worldlayers/relationships/areadescription | Describes the area selected with a string.
*WorldLayerApi* | [**world_layer_list_layers**](docs/WorldLayerApi.md#world_layer_list_layers) | **GET** /api/v1/worldlayers/layers | Enumerates every world layer in the simulation.
*WorldLayerApi* | [**world_layer_list_relevant_layers**](docs/WorldLayerApi.md#world_layer_list_relevant_layers) | **GET** /api/v1/worldlayers/layers/{focusLayer} | Enumerates the layers that should be displayed when the user is focused on a particular layer and world area.
*WorldLayerApi* | [**world_layer_list_relevant_relationships**](docs/WorldLayerApi.md#world_layer_list_relevant_relationships) | **GET** /api/v1/worldlayers/relationships/{focusLayer} | Enumerates the layer relationships that should be displayed when the user is focused on a particular layer and world area.


## Documentation For Models

 - [EcoGameplayCivicsElectionsChoiceResults](docs/EcoGameplayCivicsElectionsChoiceResults.md)
 - [EcoSharedItemsProposableState](docs/EcoSharedItemsProposableState.md)
 - [EcoSharedLocalizationLocString](docs/EcoSharedLocalizationLocString.md)
 - [EcoSharedMathRay](docs/EcoSharedMathRay.md)
 - [EcoSharedMathVector2i](docs/EcoSharedMathVector2i.md)
 - [EcoSharedMathVector3i](docs/EcoSharedMathVector3i.md)
 - [EcoSharedNetworkingServerInfo](docs/EcoSharedNetworkingServerInfo.md)
 - [EcoSharedNetworkingSkillSpecializationSetting](docs/EcoSharedNetworkingSkillSpecializationSetting.md)
 - [EcoSharedStatesServerCategory](docs/EcoSharedStatesServerCategory.md)
 - [EcoStatsGraph](docs/EcoStatsGraph.md)
 - [EcoStatsKey](docs/EcoStatsKey.md)
 - [EcoStatsNamedGraph](docs/EcoStatsNamedGraph.md)
 - [EcoStatsStatCategory](docs/EcoStatsStatCategory.md)
 - [EcoStatsStatInfo](docs/EcoStatsStatInfo.md)
 - [EcoWebServerDataTransferObjectsChatMessageDTO](docs/EcoWebServerDataTransferObjectsChatMessageDTO.md)
 - [EcoWebServerDataTransferObjectsCivicActionDTO](docs/EcoWebServerDataTransferObjectsCivicActionDTO.md)
 - [EcoWebServerDataTransferObjectsCommandResultDTO](docs/EcoWebServerDataTransferObjectsCommandResultDTO.md)
 - [EcoWebServerDataTransferObjectsDistrictDTO](docs/EcoWebServerDataTransferObjectsDistrictDTO.md)
 - [EcoWebServerDataTransferObjectsDistrictMapDTO](docs/EcoWebServerDataTransferObjectsDistrictMapDTO.md)
 - [EcoWebServerDataTransferObjectsElectedTitleDTO](docs/EcoWebServerDataTransferObjectsElectedTitleDTO.md)
 - [EcoWebServerDataTransferObjectsElectionChoiceDTO](docs/EcoWebServerDataTransferObjectsElectionChoiceDTO.md)
 - [EcoWebServerDataTransferObjectsElectionCommentDTO](docs/EcoWebServerDataTransferObjectsElectionCommentDTO.md)
 - [EcoWebServerDataTransferObjectsElectionDTO](docs/EcoWebServerDataTransferObjectsElectionDTO.md)
 - [EcoWebServerDataTransferObjectsElectionProcessDTO](docs/EcoWebServerDataTransferObjectsElectionProcessDTO.md)
 - [EcoWebServerDataTransferObjectsElectionResultsDTO](docs/EcoWebServerDataTransferObjectsElectionResultsDTO.md)
 - [EcoWebServerDataTransferObjectsEntityDTO](docs/EcoWebServerDataTransferObjectsEntityDTO.md)
 - [EcoWebServerDataTransferObjectsExecuteCommandDTO](docs/EcoWebServerDataTransferObjectsExecuteCommandDTO.md)
 - [EcoWebServerDataTransferObjectsFrontPage](docs/EcoWebServerDataTransferObjectsFrontPage.md)
 - [EcoWebServerDataTransferObjectsLawDTO](docs/EcoWebServerDataTransferObjectsLawDTO.md)
 - [EcoWebServerDataTransferObjectsMapDTO](docs/EcoWebServerDataTransferObjectsMapDTO.md)
 - [EcoWebServerDataTransferObjectsMapStats](docs/EcoWebServerDataTransferObjectsMapStats.md)
 - [EcoWebServerDataTransferObjectsPluginInfo](docs/EcoWebServerDataTransferObjectsPluginInfo.md)
 - [EcoWebServerDataTransferObjectsProfilingResultDTO](docs/EcoWebServerDataTransferObjectsProfilingResultDTO.md)
 - [EcoWebServerDataTransferObjectsRunoffVoteDTO](docs/EcoWebServerDataTransferObjectsRunoffVoteDTO.md)
 - [EcoWebServerDataTransferObjectsUserDTO](docs/EcoWebServerDataTransferObjectsUserDTO.md)
 - [EcoWebServerDataTransferObjectsVector3DTO](docs/EcoWebServerDataTransferObjectsVector3DTO.md)
 - [EcoWebServerDataTransferObjectsWorldLayersLayerRelationshipDTO](docs/EcoWebServerDataTransferObjectsWorldLayersLayerRelationshipDTO.md)
 - [EcoWebServerDataTransferObjectsWorldLayersWorldLayerDTO](docs/EcoWebServerDataTransferObjectsWorldLayersWorldLayerDTO.md)
 - [EcoWebServerDataTransferObjectsWorldLayersWorldLayerGroupDTO](docs/EcoWebServerDataTransferObjectsWorldLayersWorldLayerGroupDTO.md)
 - [EcoWebServerWebControllersStatReturn](docs/EcoWebServerWebControllersStatReturn.md)
 - [EcoWebServerWebModelsAction](docs/EcoWebServerWebModelsAction.md)
 - [EcoWebServerWebModelsAdminReturnModel](docs/EcoWebServerWebModelsAdminReturnModel.md)
 - [EcoWebServerWebModelsExportGameModel](docs/EcoWebServerWebModelsExportGameModel.md)
 - [NewtonsoftJsonLinqJToken](docs/NewtonsoftJsonLinqJToken.md)
 - [SystemNumericsVector3](docs/SystemNumericsVector3.md)


## Documentation For Authorization


## authtoken

- **Type**: API key
- **API key parameter name**: authtoken
- **Location**: URL query string

## authtokentype

- **Type**: API key
- **API key parameter name**: authtokentype
- **Location**: URL query string


## Author



